package hotelstaysgui.Controller;

import hotelstaysgui.Model.*;
import javax.swing.table.DefaultTableModel;

public class HotelStaysAdministration extends DefaultTableModel {

    Integer[][] data;
    HotelStays hotelStays;

    public HotelStaysAdministration() {
        super();
        hotelStays = new HotelStays(13, 14);
        super.setRowCount(hotelStays.getNoOfMonths() + 1);
        super.setColumnCount(hotelStays.getNoOfRooms() + 1);
        super.setColumnIdentifiers(hotelStays.getColumnNames());
        super.addColumn("Month", hotelStays.getRowNames());
        hotelStays.initializeData();
        hotelStays.fillTable();
    }

    public void setData() {
        hotelStays.fillTable();
        data = hotelStays.getStayTable();
        for (int i = 0; i < data.length; i++) {
            for (int j = 0; j < data[0].length; j++) {
                super.setValueAt(data[i][j], i, j);
            }
        }
    }

   // @Override
//    public void setValueAt(Object o, int row, int col) {
//        super.setValueAt(o, row, col);
//        if (o instanceof String) {
//            data[row][col] = Integer.valueOf((String) o);
//        } else {
//            data[row][col] = (Integer) o;
//        }
//    }

    public void printData() {
        System.out.println("Data from the table hotelstays \n\r");
        
        hotelStays.printData();
    }
    
 public void printDataFromData() {
     System.out.println("Data from the table data");
        for (int row = 0; row < data.length; row++) {
            System.out.print(row + "\t\r");
            for (int col = 0; col < data[0].length; col++) {
                //System.out.println("rowno"+ row + " colno " + col);
                System.out.print(" " + data[row][col] + "\t");
            }
            System.out.println("");
        }
    }
 
    public void printTableModel() {
        System.out.println("Data from the table-model");
        int rows = this.getRowCount();
        int cols = this.getColumnCount();
        for (int i = 0; i < cols; i++) {
            System.out.print("\t" + getColumnName(i));
        }
        System.out.println("");

        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < cols; j++) {
                System.out.print("\t" + getValueAt(i, j));
            }
            System.out.println("");
        }
        System.out.println("");
    }

     public void transferData() {
        int noOfRows = this.getRowCount();
        int noOfColumns = this.getColumnCount();
        Integer aValue;
        for (int row = 0; row < noOfRows; row++) {
            for (int col = 0; col < noOfColumns-1; col++) {
                Object o = super.getValueAt(row, col);
                if (o instanceof String) {
                    data[row][col] = Integer.valueOf((String) o);
                } else {
                    data[row][col] = (Integer) o;
                }
            }
            hotelStays.fillTable();
        }
    }

    public static void main(String args[]) {
        HotelStaysAdministration hsa = new HotelStaysAdministration();
        hsa.setData();
        hsa.printDataFromData();
        hsa.printTableModel();
    }
}
