package hotelstaysgui.Controller;

import hotelstaysgui.Model.HotelStays1;
import javax.swing.table.DefaultTableModel;

public class HotelStaysAdministration1 extends DefaultTableModel {

    Integer[][] data;
    HotelStays1 hotelStays;

    public HotelStaysAdministration1() {
        super();
        hotelStays = new HotelStays1(13, 14);
        super.setRowCount(hotelStays.getNoOfMonths() + 1);
        super.setColumnCount(hotelStays.getNoOfRooms() + 2);
        super.setColumnIdentifiers(hotelStays.getColumnNames());
        String names[] = hotelStays.getRowNames();
        for (int row = 0; row < names.length; row++) {
                super.setValueAt(names[row], row, 0);
        }
        hotelStays.initializeData();
        hotelStays.fillTable();
    }

    public void setData() {
        hotelStays.fillTable();
        data = hotelStays.getStayTable();
        for (int i = 0; i < data.length; i++) {
            for (int j = 0; j < data[0].length; j++) {
                super.setValueAt(data[i][j], i, j+1);
            }
        }
    }

    @Override
    public void setValueAt(Object o, int row, int col) {
       if (col > 0) {
           super.setValueAt(o, row, col);

        if (o instanceof String) {
            data[row][col-1] = Integer.valueOf((String) o);
        } else {
            data[row][col-1] = (Integer) o;
        }
        }
    }

    public void printData() {
        System.out.println("Data from the table \n\r");
        hotelStays.printData();
        
        printTableModel();
    }

    public void printTableModel() {
        System.out.println("Data from the table-model");
        int noOfRows = this.getRowCount();
        int noOfColumns = this.getColumnCount();
        for (int i = 0; i < noOfColumns; i++) {
            System.out.print("\t" + getColumnName(i));
        }
        System.out.println("");

        for (int i = 0; i < noOfRows; i++) {
            for (int j = 0; j < noOfColumns; j++) {
                System.out.print("\t" + getValueAt(i, j));
            }
            System.out.println("");
        }
        System.out.println("");
    }

       public void transferData() {
        int noOfRows = this.getRowCount();
        int noOfColumns = this.getColumnCount();
        Integer aValue;
        for (int row = 0; row < noOfRows; row++) {
            for (int col = 1; col < noOfColumns; col++) {
                if (super.getValueAt(row, col) instanceof String) {
                    aValue = Integer.valueOf((String) super.getValueAt(row, col));
                    hotelStays.setStays(aValue, row, col-1);
                } else {
                    aValue = (Integer) getValueAt(row, col);
                     hotelStays.setStays(aValue, row, col-1);
                }
            }
            hotelStays.fillTable();
        }

    }

    public static void main(String args[]) {
        HotelStaysAdministration1 hsa = new HotelStaysAdministration1();
        hsa.setData();
        hsa.transferData();
        hsa.printData();
        hsa.printTableModel();
        hsa.transferData();
        hsa.printData();
        hsa.printTableModel();
    }
}
