/** HotelStays.java
 * Class for holding basic data of a customer
 * @author Michael Claudius, Roskilde Computer Science College
 * @version 1.0. 2011.03.09
 * Copyright 2011 by Michael Claudius
 * All rights reserved
 */
package hotelstaysgui.Model;

import java.util.Random;

public class HotelStays1 {

//Assinment 1
    Integer[][] stayTable;
    String[] columnNames = {"Month", "101", "102", "103", "201", "201", "203",
        "204", "205", "301", "302", "303", "304", "305", "Year"};
    String[] rowNames = {"Jan", "Feb", "March", "Apr", "May", "June",
        "July", "Aug", "Sep", "Oct", "Nov", "Dec", "Year"};
    int rowMax, colMax, rowMin, colMin, noOfMonths, noOfRooms;
    Integer maximum, minimum, total, average;
    private Integer maxMonth, maxRoom;
    private int indexMaxMonth, indexMaxRoom;

    public HotelStays1() {
        stayTable = new Integer[12][30];
    }

    public HotelStays1(int noOfRows, int noOfColumns) {
        stayTable = new Integer[noOfRows][noOfColumns];
        noOfMonths = noOfRows - 1;
        noOfRooms = noOfColumns - 1;
    }

    // Assignment 2. Default initialization
    /**Initialises the table with a default value numbers
     * @param noOfStay default value of stays
     * @return void
     */
    public void defaultStay(int noOfStays) {
        for (int row = 0; row < noOfMonths; row++) {
            for (int col = 0; col < noOfRooms; col++) {
                stayTable[row][col] = noOfStays;
            }
        }
    }

//Assignment 3
    public void printData() {
        for (int row = 0; row < stayTable.length; row++) {
            System.out.print(rowNames[row] + "\t\r");
            for (int col = 0; col < stayTable[0].length -1; col++) {
                System.out.print(stayTable[row][col] + "\t\r");
            }
            System.out.println();
        }
    }

// Assignment 5. Random initialization
    /**Initialises the table with random numbers
     * @param
     * @return void
     */
    public void initializeData() {
        Random r = new Random();
        for (int row = 0; row < noOfMonths; row++) {
            for (int col = 0; col < noOfRooms; col++) {
                stayTable[row][col] = (Integer) (r.nextInt(30));
            }
        }
    }

//Assignment 6
    /**Accumulates all stays in a the table and returns this as a string
     * Traverses the table and adds the month and all tthe row stays
     * @param void
     * @return String all salary data in a string
     */
    public String toString() {
        String s = "";
        for (int row = 0; row < stayTable.length; row++) {
            s = s + rowNames[row] + "\t";
            for (int col = 0; col < stayTable[0].length; col++) {
                s = s + " " + stayTable[row][col] + "\t";
            }
            s = s + "\n";
        }
        return s;
    }

    public Integer getStays(int row, int col) {
        return stayTable[row][col];
    }

// Assignment 7. Maximum value
    /**Finds and returns maximum value
     * Traverses the table and if the elements value is lower
     * then maximum and the indices of row and column are changed
     * @param
     * @return int maximum stays
     */
    public Integer findMax() {
        maximum = stayTable[0][0];
        for (int row = 0; row < noOfMonths; row++) {
            for (int col = 0; col < noOfRooms; col++) {
                if (maximum < stayTable[row][col]) {
                    maximum = stayTable[row][col];
                    rowMax = row;
                    colMax = col;
                }
            }
        }
        return maximum;
    }

    public Integer getMax() {
        findMax();
        return maximum;
    }

//Assignment 8
    /**Calculates and returns the total sum of stays
     * Traverses the table and add each stay to the sum
     * @param
     * @return String total sum of stays
     */
    public Integer findTotal() {
        int sum = 0;
        for (int row = 0; row < noOfMonths; row++) {
            for (int col = 0; col < noOfRooms; col++) {
                sum = sum + stayTable[row][col];
            }
        }
        total = sum;
        return sum;
    }

    //Assignment 9
    public Integer findAverage() {
        int number = (noOfMonths) * noOfRooms;
        return findTotal() / number;
    }

// Assignment 10. Minimum value
    /**Finds and returns minimum value
     * Traverses the table and if the elements value is higher
     * then minimum value and the indices of row and column are changed
     * @param
     * @return int maximum stays
     */
    public Integer findMin() {
        minimum = stayTable[0][0];
        for (int row = 0; row < noOfMonths; row++) {
            for (int col = 0; col < noOfRooms; col++) {
                if (minimum > stayTable[row][col]) {
                    minimum = stayTable[row][col];
                    rowMin = row;
                    colMin = col;
                }
            }
        }
        return minimum;
    }

    //Assignment 11
    public void statData() {
        System.out.println("Total number of stays: " + findTotal());
        System.out.println("Average number of stays: " + findAverage());
        System.out.println("Maximum stays: " + findMax()
                + " in room index: " + getColMax()
                + " in month index: " + getRowMax());
        System.out.println("Minimum stays: " + findMin()
                + " in room index: " + getColMin()
                + " in month index: " + getRowMin());
        findRowMax();
        System.out.println("Best month: " + rowNames[indexMaxMonth]
                + " number of stays " + findRowMax());
        findColumnMax();
        System.out.println("Best room: " + indexMaxRoom
                + " number of stays " + findColumnMax());

        System.out.println();
    }

//Assignment 13: Total Stay in a  month; i.e. sum of a row
    /** Finds the row-sum of a specific row
    /* @param
     * @return Intger the total stay in a specific month
    /* Traverses the row
    /* Calculates and returns the sum of the stays in the row
     */
    public Integer findRowSum(int row) {
        int sum = 0;
        for (int col = 0; col < noOfRooms; col++) {
            sum = sum + stayTable[row][col];
        }
        return sum;
    }

    /** Traverses all the rows
    /* For each row calculates the row sum
    /* Places the row sum in the element of the last column
     */
    public void fillRowSum() {
        for (int row = 0; row < noOfMonths; row++) {
            Integer sum = findRowSum(row);
            // System.out.println("row"+row+"sum"+sum);
            stayTable[row][stayTable[0].length - 1] = sum;
            //Alternatively
            //stayTable[row][noOfRooms] = findRowSum(row);;
        }
    }

    //Assignment 14: Best month
    /** Finds and returns the maximum row-sum of all rows
    /* @param
     * @return Intger the maximum stays of all months
    /*  Traverses the table rows and if the row sum higher
     * then maximum month and the index of row are ch
     */
    public Integer findRowMax() {
        maxMonth = findRowSum(0);
        indexMaxMonth = 0;
        int sum = 0;
        for (int row = 1; row < noOfMonths; row++) {
            sum = findRowSum(row);
            //System.out.println("Rowsum: " + sum + " " + row);
            if (maxMonth < sum) {
                indexMaxMonth = row;
                maxMonth = sum;
            }
        }
        return maxMonth;
    }

    public Integer findColumnSum(int col) {
        int sum = 0;
        for (int row = 0; row < noOfMonths; row++) {
            sum = sum + stayTable[row][col];
        }
        return sum;
    }

    public void fillColumnSum() {
        for (int col = 0; col < noOfRooms; col++) {
            stayTable[stayTable.length - 1][col] = findColumnSum(col);
        }
    }

    public Integer findColumnMax() {
        int colNo = 0;
        Integer max = findColumnSum(0);
        int sum = 0;
        for (int col = 1; col < noOfRooms; col++) {
            sum = findColumnSum(col);
            //System.out.println("Column sum: " + sum + " " + col);
            if (max < sum) {
                colNo = col;
                max = sum;
            }
        }
        maxRoom = max;
        indexMaxRoom = colNo;
        return max;
    }

    public void fillTotal() {
        stayTable[stayTable.length - 1][stayTable[0].length - 1] = findTotal();
    }

    public void fillTable() {
        fillColumnSum();
        fillRowSum();
        fillTotal();
    }
//Get and set methods for all data fields

    public Integer getAverage() {
        return average;
    }

    public void setAverage(Integer average) {
        this.average = average;
    }

    public int getColMax() {
        return colMax;
    }

    public void setColMax(int colMax) {
        this.colMax = colMax;
    }

    public int getColMin() {
        return colMin;
    }

    public void setColMin(int colMin) {
        this.colMin = colMin;
    }

    public Integer getMaximum() {
        return maximum;
    }

    public void setMaximum(Integer maximum) {
        this.maximum = maximum;
    }

    public Integer getMinimum() {
        return minimum;
    }

    public void setMinimum(Integer minimum) {
        this.minimum = minimum;
    }

    public int getRowMax() {
        return rowMax;
    }

    public void setRowMax(int rowMax) {
        this.rowMax = rowMax;
    }

    public int getRowMin() {
        return rowMin;
    }

    public void setRowMin(int rowMin) {
        this.rowMin = rowMin;
    }

    public String[] getRowNames() {
        return rowNames;
    }

    public void setRowNames(String[] rowNames) {
        this.rowNames = rowNames;
    }

    public Integer[][] getStayTable() {
        return stayTable;
    }

    public void setStayTable(Integer[][] stayTable) {
        this.stayTable = stayTable;
    }

    public Integer getTotal() {
        return total;
    }

    public void setTotal(Integer total) {
        this.total = total;
    }

    public int getIndexMaxMonth() {
        return indexMaxMonth;
    }

    public void setIndexMaxMonth(int indexMaxMonth) {
        this.indexMaxMonth = indexMaxMonth;
    }

    public Integer getMaxMonth() {
        return maxMonth;
    }

    public void setMaxMonth(Integer maxMonth) {
        this.maxMonth = maxMonth;
    }

    public int getNoOfMonths() {
        return noOfMonths;
    }

    public void setNoOfMonths(int noOfMonths) {
        this.noOfMonths = noOfMonths;
    }

    public int getNoOfRooms() {
        return noOfRooms;
    }

    public void setNoOfRooms(int noOfRooms) {
        this.noOfRooms = noOfRooms;
    }

    public String[] getColumnNames() {
        return columnNames;
    }

    /**Sets the stays of the element at the position index
     * @param  amount The amount to be added to the element
     * @param index Position of element
     * @return void
     */
    public void setStays(Integer stay, int row, int col) {
        stayTable[row][col] = stay;
    }
}
